$OPTIMIZE SPEED
$LIB ALL OFF

DEFINT A-Z
%YES = -1
%NO = 0

' Look in COMMAND$ for the file to process
InFile$ = UCASE$(COMMAND$)
IF ISFALSE(LEN(InFile$)) THEN
  PRINT "Usage: CRC16 <filename>"
  END
END IF

InFile% = FREEFILE
OPEN InFile$ FOR BINARY AS InFile%
FileBytes& = LOF(InFile%)
IF ISFALSE(FileBytes&) THEN         ' if zero length
  CLOSE InFile% : KILL InFile$
  PRINT "Cannot find file "; InFile$
  END
END IF

MTIMER
PRINT "FileName$: "; InFile$, "FileBytes&: "; FileBytes&
CRCvalue% = FileCRC16%(InFile%)
CLOSE InFile%
s1#=MTIMER/1000000
PRINT "Time elapsed:"; USING "##.######"; (s1#);
PRINT " seconds"
PRINT "CRC: "; CRCvalue%
END


FUNCTION FileCRC16%(BYVAL InFile%) PUBLIC

  ' Optimize for speed by placing local vars accessed most heavily at the end of
  ' the locals list
  LOCAL InBuffSize%, InBuff$, BuffSeg&, BuffAdr&, BytesLeft&, FileDone%, saver%

  'create the largest buffer possible
  InBuffSize% = FRE(t$)
  InBuff$ = STRING$(InBuffSize%, 0)
  BuffSeg& = STRSEG(InBuff$)
  BuffAdr& = STRPTR(InBuff$)
  BytesLeft& = LOF(InFile%)
  SEEK InFile%, 0
  GOSUB LoadInBuff

  DO
    GOSUB CRCstring
    GOSUB LoadInBuff
  LOOP UNTIL ISTRUE(FileDone%)

  FileCRC16% = saver%
  EXIT FUNCTION

  LoadInBuff:
  ' Load buffer with bytes from file
  ' If process is complete, return FileDone% as true
  IF ISTRUE(BytesLeft&) THEN
    ' If remaining bytes < buffer then resize the buffer
    IF Bytesleft& < InBuffSize% THEN
      InBuffSize% = BytesLeft&
      InBuff$ = STRING$(InBuffSize%,0)
      BuffSeg& = STRSEG(InBuff$)
      BuffAdr& = STRPTR(InBuff$)
    END IF
    GET InFile%,,InBuff$
    ' Tally bytes left to process
    DECR BytesLeft&, InBuffSize%
  ELSE
    FileDone% = %YES
  END IF
  RETURN


  CRCstring:
  ' Save any regs used other than ax, bx, cx, dx, and es
  !  pushf
  !  push  ds
  !  push  si
  !  push  di
  ' Load address and length of string$
  !  mov   ds, BuffSeg&
  !  mov   si, BuffAdr&       ; now ds:si -> InBuff$
  !  mov   cx, InBuffSize%
  !  cld                      ; move forward through buffer
  !  mov   dx, saver%         ; saver% = 0 if first pass
  ByteLoop:
  !  lodsb                    ; now al = byte at ds:si
  !  SUB   ah, ah
  !  xchg  ah, al
  !  XOR   dx, ax
  !  mov   di, 8              ; use di to track bits
  BitLoop:
  !  mov   bx, dx
  !  shl   dx, 1
  !  AND   bx, &H8000
  !  jz    NextBit
  !  XOR   dx, &H1021
  NextBit:
  !  dec   di
  !  jnz   BitLoop
  !  dec   cx
  !  jnz   ByteLoop
  !  mov   saver%, dx         ; store resulting value - the CRC
  DoneFileCRC16:
  ' Clean up
  !  pop   di
  !  pop   si
  !  pop   ds
  !  popf
  RETURN

END FUNCTION
